#ifndef AD_SHARC_FI_H
#define AD_SHARC_FI_H

/* Compilers may use another function within the assert macro to exit the 
 * program. QAC thus does not see an "exit" function and assumes the 
 * function returns, which it does not.
 * The below pragma tells QAC the compiler supplied function does not
 * return.
 */

/* examples - GCC, ICC, BCC 3.1, BCC 5.5, CYGWIN gcc, Watcom 1.6 */
#pragma PRQA_NO_RETURN __assert_fail
#pragma PRQA_NO_RETURN __assert_perror_fail
#pragma PRQA_NO_RETURN __assert

/* SDCC, BCC 5.5, Digital Mars DM 8.4, LCC, Watcom 1.6, Fujitsu F2MM,FR */
#pragma PRQA_NO_RETURN _assert

/* HI-TECH PCCLite */
#pragma PRQA_NO_RETURN _fassert

/* DJGPP, D.J.Delorie gcc DOS port */
#pragma PRQA_NO_RETURN __dj_assert

/* Watcom 1.6, MSVS 08 */
#pragma PRQA_NO_RETURN _wassert
#pragma PRQA_NO_RETURN __wassert
#pragma PRQA_NO_RETURN _assert99
#pragma PRQA_NO_RETURN _wassert99
#pragma PRQA_NO_RETURN __assert99
#pragma PRQA_NO_RETURN __wassert99

/* Renesas M32R compiler */
#pragma PRQA_NO_RETURN _Assert

/* NEC 78K0 series 16bit compiler */
#pragma PRQA_NO_RETURN __assertfail
#pragma PRQA_NO_RETURN __assertfail_n
#pragma PRQA_NO_RETURN __assertfail_f


/* Depending on the code that the compiler maker uses within the assert macro,
 * QAC may issue warnings. It is also possible that when the NDEBUG macro is used
 * to suppress the assertion code, QAC may issue a "no side-effects" warning.
 * To eliminate these, we turn off all warnings for the assert macro.
 */
#pragma PRQA_MACRO_MESSAGES_OFF "assert"


/* Any other items that may be required in a "force-include" file should be placed below. */
int __builtin_LRxLR(int, int);
void __builtin_NOP(void);
int __builtin_RxItoI(int, int);
int __builtin_RxItoR(int, int);
int __builtin_RxR(int, int);
int __builtin_abs(int);
void __builtin_aligned(const void *, int);
void *__builtin_alloca(unsigned long);
void __builtin_assert(int);
int __builtin_avg(int, int);
int __builtin_circindex(int, int, unsigned long);
void *__builtin_circptr(const void *, int, const void *, unsigned long);
int __builtin_clip(int, int);
int __builtin_conv_FtoR(float);
int __builtin_conv_LRtoR(int);
float __builtin_conv_RtoF(int);
int __builtin_conv_RtoLR(int);
int __builtin_conv_fix(float);
float __builtin_copysignf(float, float);
void *__builtin_dealloca(unsigned long);
long __builtin_emuclk(void);
int __builtin_expected_false(int);
int __builtin_expected_true(int);
long double __builtin_fabs(long double);
float __builtin_fabsf(float);
float __builtin_favgf(float, float);
float __builtin_fclipf(float, float);
float __builtin_fmaxf(float, float);
float __builtin_fminf(float, float);
int __builtin_fpack(float);
float __builtin_fsignf(float, float);
int __builtin_funcsize(const void *);
float __builtin_funpack(int);
void __builtin_idle(void);
long __builtin_labs(long);
long __builtin_lavg(long, long);
long __builtin_lclip(long, long);
long __builtin_lmax(long, long);
long __builtin_lmin(long, long);
int __builtin_logbf(float);
int __builtin_mantf(float);
int __builtin_max(int, int);
void *__builtin_memcpyDD(void *, const void *, unsigned long);
void *__builtin_memcpyDP(void *, const void *, unsigned long);
void *__builtin_memcpyPD(void *, const void *, unsigned long);
void *__builtin_memcpyPP(void *, const void *, unsigned long);
void *__builtin_memmoveDD(void *, const void *, unsigned long);
void *__builtin_memmoveDP(void *, const void *, unsigned long);
void *__builtin_memmovePD(void *, const void *, unsigned long);
void *__builtin_memmovePP(void *, const void *, unsigned long);
int __builtin_min(int, int);
int __builtin_misaligned_load32(void *);
int __builtin_misaligned_load32_vol(volatile void *);
void __builtin_misaligned_store32(void *, int);
void __builtin_misaligned_store32_vol(volatile void *, int);
void __builtin_pm_aligned(const void *, int);
char *__builtin_strcpyDD(char *, const char *);
char *__builtin_strcpyDP(char *, const char *);
char *__builtin_strcpyPD(char *, const char *);
char *__builtin_strcpyPP(char *, const char *);
unsigned long __builtin_strlenD(const char *);
unsigned long __builtin_strlenP(const char *);
void __builtin_sysreg_bit_clr(int, unsigned int);
void __builtin_sysreg_bit_clr_nop(int, unsigned int);
void __builtin_sysreg_bit_set(int, unsigned int);
void __builtin_sysreg_bit_set_nop(int, unsigned int);
void __builtin_sysreg_bit_tgl(int, unsigned int);
void __builtin_sysreg_bit_tgl_nop(int, unsigned int);
int __builtin_sysreg_bit_tst(int, unsigned int);
int __builtin_sysreg_bit_tst_all(int, unsigned int);
int __builtin_sysreg_bit_xor(int, unsigned int);
unsigned int __builtin_sysreg_read(int);
void __builtin_sysreg_write(int, unsigned int);
void __builtin_sysreg_write_nop(int, unsigned int);
void *__builtin_va_start(const void *, int);

#else
#error "Multiple include"
#endif  /* ifndef AD_SHARC_FI_H */
